#include <bits/stdc++.h>
using namespace std;
#define f(x, y, z) for(int x = (y); x <= (z); ++x)
#define g(x, y, z) for(int x = (y); x < (z); ++x)
#define h(x, y, z) for(int x = (y); x >= (z); --x)

mt19937_64 rng;

double randDouble()
{
    static mt19937_64 rng;
    return rng() / (1. + rng.max());
}

int nextFileId = 10;

struct File: vector<pair<int, int>>
{
    void dump(ostream &out) const
    {
        out << size() / 2 << endl;
        bool first = true;
        for(const pair<int, int> &p: *this)
        {
            if(first) first = false; else out << ' ';
            out << p.first;
        }
        out << endl;
        first = true;
        for(const pair<int, int> &p: *this)
        {
            if(first) first = false; else out << ' ';
            out << p.second;
        }
        out << endl;
    }
    void dumpNext() const
    {
        int fileId = nextFileId++;
        ofstream out("data/" + to_string(fileId) + ".in");
        dump(out);
    }
};

File genFile(int mindx = 1, int maxdx = 100, int maxn = 100, int maxa = 100)
{
    int n = rng() % maxn + 1;
    File ans;
    ans.resize(n * 2);
    g(i, 0, 2 * n) ans[i].first = rng() % (maxa + 1);
    g(i, 0, 2 * n)
    {
        int dx = rng() % (i % n + 2);
        dx = max(mindx, min(dx, maxdx));
        int x = i + 1 - dx;
        if(x < i / n * n + 1) x = 0;
        ans[i].second = x;
    }
    return ans;
}

int main()
{
    g(_, 0, 10) genFile(1, 1).dumpNext();
    g(_, 0, 10) genFile(100, 100).dumpNext();
    g(_, 0, 10) genFile().dumpNext();
    return 0;
}
