#!/usr/bin/env python3

import sys

n = int(sys.stdin.readline())
a = list(map(int, sys.stdin.readline().split()))
b = list(map(int, sys.stdin.readline().split()))
pre = [set() for _ in range(n * 2)]
for p, q in enumerate(b):
    if q > 0:
        q -= 1
        pre[q].add(p)

apples = []
pears = []
apples_left = set()
pears_left = set()
for i, p in enumerate(pre[:n]):
    if not p:
        apples.append(i)
    else:
        apples_left.add(i)
for i, p in enumerate(pre[n:]):
    if not p:
        pears.append(i + n)
    else:
        pears_left.add(i + n)

values = []
for _ in range(n):
    value, p, q = None, None, None
    for x in apples:
        for y in pears:
            current = a[x] ^ a[y]
            if (value is None) or (current, a[x], x, y) > (value, a[p], p, q):
                value, p, q = current, x, y
    values.append(value)
    apples.remove(p)
    pears.remove(q)
    apples_new = []
    for i in apples_left:
        pre[i].discard(p)
        if not pre[i]:
            apples_new.append(i)
    pears_new = []
    for i in pears_left:
        pre[i].discard(q)
        if not pre[i]:
            pears_new.append(i)
    apples.extend(apples_new)
    pears.extend(pears_new)
    for i in apples_new:
        apples_left.remove(i)
    for i in pears_new:
        pears_left.remove(i)
sys.stdout.write(' '.join(str(v) for v in values) + '\n')
